#include <ctype.h>
#include <stdio.h>
#include <fcntl.h>
#include <memory.h>
#include <stdlib.h>
#include <unistd.h>

int
main(int argc, char *argv[])
{
  int fd, fd2, ret, i;
  char *buf;
  char *filename;
  int filesize;

  if (argc != 3) {
    printf("usage: %s filename size\n", argv[0]);
    exit(1);
  }
  filename = argv[1];
  filesize = atoi(argv[2]);
  buf = malloc(filesize);
  if (!buf) {
    perror("malloc");
    exit(1);
  }
  fd = open(filename, O_RDONLY);
  if (fd < 0) {
    perror(filename);
    exit(1);
  }
  fd2 = open(filename, O_RDONLY);
  if (fd2 < 0) {
    perror(filename);
    exit(1);
  }
  memset(buf, 0, filesize);
  ret = read(fd, buf, filesize);
  if (ret != filesize) {
    fprintf(stdout, "read returned %d\n", ret);
    perror("read");
  } else {
    for (i=0; i<ret; ++i)
      printf("byte[%d] = %x (%c)\n", i,
	     buf[i],
	     (isprint((int)buf[i]) ? buf[i] : '?'));
  }
  close(fd);
  close(fd2);
  exit(0);
}
